import sys, threading, time
from PyQt5 import QtCore, QtGui, QtWidgets

qApp = QtWidgets.QApplication(sys.argv)

# tree view with signals
class myTreeView(QtWidgets.QTreeView):
    addRowSignal = QtCore.pyqtSignal(int)
    changeRowSignal = QtCore.pyqtSignal(int)
    pm = QtGui.QPixmap(19,19)
    pm2 = QtGui.QPixmap(20,20)

    def __init__(self, parent=None):
        QtWidgets.QTreeView.__init__(self, parent)
        self.addRowSignal.connect(self.AddRow)
        self.changeRowSignal.connect(self.ChangeRows)

    #add a row to the treeview
    def AddRow(self, counter):
        row = [QtGui.QStandardItem("myItem " + str(counter)), QtGui.QStandardItem("myItem " + str(counter))]
        row[-1].setData(self.pm, QtCore.Qt.DecorationRole)
        m.appendRow(row)
    
    #remove the first row and append a new row
    def ChangeRows(self, counter):
        m.invisibleRootItem().removeRow(0)
        row = [QtGui.QStandardItem("myItem " + str(counter)), QtGui.QStandardItem("myItem " + str(counter))]
        row[-1].setData(self.pm, QtCore.Qt.DecorationRole)
        m.invisibleRootItem().child(0).setData(self.pm2, QtCore.Qt.DecorationRole) # modify item from item model
        m.appendRow(row)

#setup some instances in the main thread
tv = myTreeView()
m = QtGui.QStandardItemModel()
tv.setModel(m)
counter = 0

# initially add three rows
tv.addRowSignal.emit(counter)
counter = counter + 1
tv.addRowSignal.emit(counter)
counter = counter + 1
tv.addRowSignal.emit(counter)
counter = counter + 1

# separate thread to update the items
class MyThread(threading.Thread):
    def run(self):
        while (True):
            global counter
            tv.changeRowSignal.emit(counter)
            counter = counter + 1
            tv.changeRowSignal.emit(counter)
            counter = counter + 1
            tv.changeRowSignal.emit(counter)
            counter = counter + 1
            time.sleep(0.01) # if you set to 0.001 then python.exe crashes more often
myThread=MyThread()
myThread.start()

#show and exec
tv.show()
qApp.exec_()